/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeOpenStackMachineTemplates implements OpenStackMachineTemplateInterface
type FakeOpenStackMachineTemplates struct {
	Fake *FakeInfrastructureV1beta1
	ns   string
}

var openstackmachinetemplatesResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta1", Resource: "openstackmachinetemplates"}

var openstackmachinetemplatesKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta1", Kind: "OpenStackMachineTemplate"}

// Get takes name of the openStackMachineTemplate, and returns the corresponding openStackMachineTemplate object, and an error if there is any.
func (c *FakeOpenStackMachineTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.OpenStackMachineTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(openstackmachinetemplatesResource, c.ns, name), &v1beta1.OpenStackMachineTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachineTemplate), err
}

// List takes label and field selectors, and returns the list of OpenStackMachineTemplates that match those selectors.
func (c *FakeOpenStackMachineTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.OpenStackMachineTemplateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(openstackmachinetemplatesResource, openstackmachinetemplatesKind, c.ns, opts), &v1beta1.OpenStackMachineTemplateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.OpenStackMachineTemplateList{ListMeta: obj.(*v1beta1.OpenStackMachineTemplateList).ListMeta}
	for _, item := range obj.(*v1beta1.OpenStackMachineTemplateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested openStackMachineTemplates.
func (c *FakeOpenStackMachineTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(openstackmachinetemplatesResource, c.ns, opts))

}

// Create takes the representation of a openStackMachineTemplate and creates it.  Returns the server's representation of the openStackMachineTemplate, and an error, if there is any.
func (c *FakeOpenStackMachineTemplates) Create(ctx context.Context, openStackMachineTemplate *v1beta1.OpenStackMachineTemplate, opts v1.CreateOptions) (result *v1beta1.OpenStackMachineTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(openstackmachinetemplatesResource, c.ns, openStackMachineTemplate), &v1beta1.OpenStackMachineTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachineTemplate), err
}

// Update takes the representation of a openStackMachineTemplate and updates it. Returns the server's representation of the openStackMachineTemplate, and an error, if there is any.
func (c *FakeOpenStackMachineTemplates) Update(ctx context.Context, openStackMachineTemplate *v1beta1.OpenStackMachineTemplate, opts v1.UpdateOptions) (result *v1beta1.OpenStackMachineTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(openstackmachinetemplatesResource, c.ns, openStackMachineTemplate), &v1beta1.OpenStackMachineTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachineTemplate), err
}

// Delete takes name of the openStackMachineTemplate and deletes it. Returns an error if one occurs.
func (c *FakeOpenStackMachineTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(openstackmachinetemplatesResource, c.ns, name, opts), &v1beta1.OpenStackMachineTemplate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeOpenStackMachineTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(openstackmachinetemplatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.OpenStackMachineTemplateList{})
	return err
}

// Patch applies the patch and returns the patched openStackMachineTemplate.
func (c *FakeOpenStackMachineTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.OpenStackMachineTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(openstackmachinetemplatesResource, c.ns, name, pt, data, subresources...), &v1beta1.OpenStackMachineTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachineTemplate), err
}
